import { isPropValid, cleanClassesTag } from './lib/index'
import tags from './lib/tags'
import createRender from './lib/create-preact-render'

export default function styledFn(tag, styledClassName) {
  return createRender(tag, styledClassName, isPropValid)
}

let styled = styledFn

tags.forEach(tag => {
  styled[tag] = (...rest) => {
    return styledFn(tag, (props, theme) =>
      cleanClassesTag(rest, { props, theme })
    )
  }
})

export { styled }
